local syntax = require "core.syntax"

syntax.add {
  files = { "%.java$" },
  comment = "//",
  patterns = {
    { pattern = "//.-\n",               type = "comment"  },
    { pattern = { "/%*", "%*/" },       type = "comment"  },
    { pattern = { '"', '"', '\\' },     type = "string"   },
    { pattern = { "'", "'", '\\' },     type = "string"   },
    { pattern = "'\\x%x?%x?%x?%x'",         type = "string"   }, -- character hexadecimal escape sequence
    { pattern = "'\\u%x%x%x%x'",            type = "string"   }, -- character unicode escape sequence
    { pattern = "'\\?.'",                   type = "string"   }, -- character literal
    { pattern = "-?0x%x+",              type = "number"   },
    { pattern = "-?%d+[%d%.eE]*f?",     type = "number"   },
    { pattern = "-?%.?%d+f?",           type = "number"   },
    { pattern = "[%+%-=/%*%^%%<>!~|&]", type = "operator" },
    { pattern = "[%a_][%w_]*%f[(]",     type = "function" },
    { pattern = "[%a_][%w_]*",          type = "symbol"   },
  },
  symbols = {
    ["if"]       = "keyword",
    ["then"]     = "keyword",
    ["else"]     = "keyword",
    ["else if"]   = "keyword",
    ["do"]       = "keyword",
    ["while"]    = "keyword",
    ["for"]      = "keyword",
    ["new"]      = "keyword",
    ["break"]    = "keyword",
    ["continue"] = "keyword",
    ["return"]   = "keyword",
    ["goto"]     = "keyword",
    ["class"]   = "keyword",
    ["implements"]   = "keyword",
    ["extends"]   = "keyword",
    ["private"]  = "keyword",
    ["protected"] = "keyword",
    ["public"]   = "keyword",
    ["abstract"]   = "keyword",
    ["interface"]   = "keyword",
    ["assert"]   = "keyword",
    ["import"]   = "keyword",
    ["native"]   = "keyword",
    ["package"]   = "keyword",
    ["super"]   = "keyword",
    ["synchronized"]   = "keyword",
    ["instanceof"]      = "keyword",
    ["enum"]     = "keyword",
    ["catch"]    = "keyword",
    ["throw"]    = "keyword",
    ["throws"]    = "keyword",
    ["try"]      = "keyword",
    ["transient"]   = "keyword",
    ["finally"]      = "keyword",
    ["static"]   = "keyword",
    ["volatile"] = "keyword",
    ["final"]    = "keyword",
    ["switch"]   = "keyword",
    ["case"]     = "keyword",
    ["default"]  = "keyword",
    ["void"]     = "keyword",
    ["int"]      = "keyword2",
    ["short"]    = "keyword2",
    ["byte"]    = "keyword2",
    ["long"]     = "keyword2",
    ["float"]    = "keyword2",
    ["double"]   = "keyword2",
    ["char"]     = "keyword2",
    ["boolean"]     = "keyword2",
    ["true"]     = "literal",
    ["false"]    = "literal",
    ["null"]     = "literal",
  },
}
